unit Kalender;
interface
uses sysutils;

function kalenderwoche(jetzt : tdatetime):integer;
function KWZeitpunkt(KW : longint):tdatetime;
implementation


function KWZeitpunkt(KW : longint):tdatetime;
var
  Jahr              : longint;
  Monat, Tag        : Word;
  neujahr           : tdatetime;
  Datum             : tdatetime;
  Vergangen         : integer;
  NeuJahrstag       : Integer;
  woche             : longint;
  NeuJahrKW         : integer;

 begin
  Jahr := KW div 100;
  woche := KW mod 100;
  monat := 1;
  tag   := 1;
  neujahr := encodedate(jahr,monat,tag);

  repeat
     NeuJahrKW := kalenderwoche(neujahr);
     datum := neujahr;
     neujahr := neujahr + 7;
     until (NeuJahrKW = woche)or(NeuJahrKW>53);
    // until (NeuJahrKW = woche)or(NeuJahrKW>=53);
    //funktioniert nur wenn Neujahr nicht in KW53 des letzten Jahres liegt.
  result := neujahr-7;


  end;

{ from: Ralf.Leidinger@Ibm.net (Ralf Leidinger Ingenieurbro Leidinger)
I have written some functions to deal with dates and weeks as well
following the the DIN (German norm). The function itself are small and
quick but I have include a lot commentary. I'am sorry that the
comments are in German but I will translate them if some needs Englishversion.
}


function GermanDayOfWeek(aDate: TDateTime): Integer;
begin
  Result := (DateTimeToTimeStamp(aDate).Date + 6) mod 7 + 1;
  end;


function WeeksOfYear(aYear: Integer): Integer;
var
  dayOfFirstJan: Integer;
  begin
  dayOfFirstJan := GermanDayOfWeek( EncodeDate(aYear, 1, 1));
  If (dayOfFirstJan = 4) or ((dayOfFirstJan = 3) and IsLeapYear(aYear)) then
    Result := 53  else    Result := 52;
    end;

function YearOfDate(aDate: TDateTime): Integer;
var  Year, Month, Day: Word;
begin
  DecodeDate( aDate, Year, Month, Day);  Result := Year;
  end;


function DayOfYear( aDate: TDateTime ): Integer;
  begin
  Result := Round(aDate - EncodeDate( YearOfDate(aDate), 1, 1)) + 1;
  end;

function IsLeapYear( aYear: Integer): Boolean;
  begin
  Result := (aYear mod 4 = 0) and ((aYear mod 100 <> 0) or (aYear mod 400 = 0));
  end;

{ die erste Kalenderwoche nach DIN ist die Woche in welche mindestens
  vier der ersten 7 Tage des Monats Januar fallen.
  Der erste Wochentag ist der Montag der 7. Wochentag ist der Sonntag.
  Daraus folgt:  Beachte: Die Funktion DayOfWeek liefer 1 fr Sonntag und 7 fr
Samstag}

function WeekOfDate( aDate: TDateTime ): Integer;
var
  FirstJanuary: TDateTime;  dayOfFirstJanuary: Integer;  dayOfYear: Integer;
  Day, Month, Year: Word;
  begin  DecodeDate(aDate, Year, Month, Day);
  { build date of 1. Januar of year }
  FirstJanuary := EncodeDate(Year, 1, 1);
  { get weekday of first january }
  DayOfFirstJanuary := GermanDayOfWeek(FirstJanuary);
  { calculate the day number }
  // dayOfYear := DateTimeToTimeStamp(aDate - FirstJanuary).Date + 1;
  dayOfYear := Round(aDate - FirstJanuary) + 1;

  if DayOfFirstJanuary > 4 then
    Dec( dayOfYear, (8 - DayOfFirstJanuary))
    else
    Inc( dayOfYear, DayOfFirstJanuary - 1);  { calculate the week of the year }
  Result := (dayOfYear + 6) div 7;

  if Result = 0 then
    Result := WeeksOfYear(Year-1)
  else if Result > WeeksOfYear(Year) then
    Result := 1;

    { Now we check if we have relay such may weeks in our year.
    It's possible for the last days of the Year to belong to the firstweek of
    the next week. This can happen only if the Result = 53 but the current
    Year only consists of 52 weeks. }

    end;

    { berechne wieviele Wochen ein Jahr hat
    Fr die Berechnung der Wochenanzahl mu~ die Anzahl der Tage desJahres
    rechnerisch korrigiert werden so da~ immer ein ganzahligesvielfaches
    von 7 entsteht (Ein Jahr kann maximal 53 Wochen haben).
    Laut Brockhaus beginnt eine Woche mit dem Kalendertag Montag.
    Die erste Wochen eines Jahres nach DIN ist die Woche in welche
    mindestens vier der ersten 7 Tage des Monats Januar fallen.
    Daraus ergibt sich:
    Beginnt das Jahr mit einem Freitag, Samstag oder Sonntag dann zhlen
    diese Tage noch zur letzten Woche des alten Jahres. Die Anzahl der
    Tage des Jahres zur Berechnung der Wochenanzahl vermindert sichsomit
    entsprechend um 3, 2, oder 1 Tag.
    Beginnt das Jahr mit einem Dienstag, Mittwoch oder Donnerstag,dann zhlen
    auch der Montag, Dienstag und Mittwoch des vergangen Jahres zurWoche 1
    des neuen Jahres. Die Anzahl der Tage des Jahres zur Berechnungerhht sich
    somit entsprechend um 1, 2, oder 3 Tage,
    Gleiches gilt fr das Ende des Jahres. Endet das Jahr mit einemMontag,
    Dienstag oder Mittwoch zhlen diese Tage bereits zur 1. Woche desnchsten
    Jahres, die Anzahl der Tage mu~ also entsprechend um 1, 2 oder 3Tage
    reduziert werden.
    Endet das Jahr mit einem Donnerstag, Freitag oder Samstag, dannzhlen die
    Tage Freitag, Samstage respektiv Sonntag des neuen Jahres noch zurletzten
    Woche diesen Jahres, die Anzahl Tage mu~ also entsprechend um 3, 2oder
    1 Tag erhht werden.
    Fr ein normales Jahr hat der 31. Dezember den gleichen Wochentagwie der
    1. Januar. Fr ein Schaltjahr den nchst folgenden.
    In den folgenden beiden Tabellen ist der Zugewinn oder Verlust anTagen
    eines Jahres aufgefhrt in Abhhngigkeit davon mit welchemWochentag das
    Jahr beginnt und endet. Plus bedeutet es werden Tagehinzugewonnen, Minus
    bedeutet einen Verlust.
    In der ersten Spalte ist der Gewinn/Verlust bezogen auf den1.Januar des
    Jahres dargestellt. In der zweiten Spalte entsprechend fr den 31.Dezember.
    In der Spalte Diff ist der Gesamtverlust - oder -gewinndargestellt.
    Die Spalte Tage enthlt die Anzahl Tage des Jahres welche derBerechnung
    der Wochenanzahl (Spalte Wo) zugrunde liegt (Wo = Tage div 7).
    Es ist zu erkennen, da~ ein normales Jahr in der Regel mit 364Tagen auf
    genau 52 Wochen kommt. Ist der 1. Januar jedoch ein Donnerstag,dann hat
    das Jahr mit 371 Tage genau 53  Wochen.
    Ebenso berechnet sich die Anzahl Tage eines Schaltjahrs in derRegel auf
    364 was genau 52 Wochen entspricht. Ist der 1. Januar jedoch ein
    Mittwoch ODER Donnerstag, dann hat das Jahr 371 Tag
         Normales Jahr  (365 Tage)                 Schaltjahr (366Tage)
    1.Jan          31.Dez   Diff Tage Wo   1.Jan       31.DezDiff Tage Wo
    (mo) +0  +  (mo) -1   =  -1  364  52   (mo) +0  +  (di) -2   =  -2364  52
    (di) +1  +  (di) -2   =  -1  364  52   (di) +1  +  (mi) -3   =  -2364  52
    (mi) +2  +  (mi) -3   =  -1  364  52   (mi) +2  +  (do) +3   =  +5371  53
    (do) +3  +  (do) +3   =  +6  371  53   (do) +3  +  (fr) +2   =  +5371  53
    (fr) -3  +  (fr) +2   =  -1  364  52   (fr) -3  +  (sa) +1   =  -2364  52
    (sa) -2  +  (sa) +1   =  -1  364  52   (sa) -2  +  (so) +0   =  -2364  52
    (so) -1  +  (so) +0   =  -1  364  52   (so) -1  +  (mo) -1   =  -2364  52
    Die Funktion mu~ also lediglich ermitteln welchen Wochentag der 1.Januar
    des Jahres ist und entsprechend der beiden Tabellen die Anzahl der
    Wochen bestimmen}




function kalenderwoche(jetzt : tdatetime):integer;
var
  Jahr, Monat, Tag  : Word;
  neujahr           : tdatetime;
  Vergangen         : integer;
  NeuJahrstag       : Integer;
 begin
 {
  decodedate(jetzt,Jahr, Monat, Tag);
  monat := 1;
  tag   := 1;
  neujahr := encodedate(jahr,monat,tag);
  Neujahrstag := dayofweek(neujahr)-1;  //Montag ist der erste Tag in der Woche
  if Neujahrstag = 0 then neujahrstag := 7;
  vergangen := (neujahrstag+trunc(jetzt - neujahr)-1) div 7;
  if Neujahrstag >= 4 then result := vergangen + 1
                      else result := vergangen;
  }
  result := WeekOfDate(jetzt);
   end;


 end.
